#include <bits/stdc++.h>

using namespace std;

long long f(vector<int> t, int k) {
    if (k) {
        long long sum = 0;
        for (int i = 0; i < t.size(); i++) {
            for (int j = i + 1; j <= t.size(); j++) {
                vector<int>::const_iterator first = t.begin() + i;
                vector<int>::const_iterator last = t.begin() + j;
                vector<int> t1(first, last);

                sum += f(t1, k - 1);
                sum %= 1000000007;
            }
        }
        return sum;
    }

    long long sum = 0;
    for (int const& x : t) {
        sum += x % 1000000007;
        sum %= 1000000007;
    }

    return sum;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, k;

    cin >> n >> k;

    int a_i;
    vector<int> a;

    for (int i = 0; i < n; i++) {
        cin >> a_i;
        a.push_back(a_i);
    }

    cout << f(a, k);
}